Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.cpp	(revision 54)
@@ -39,4 +39,11 @@
 #include "TDecTop.h"
 
+#if SVC_EXTENSION
+ParameterSetManagerDecoder TDecTop::m_parameterSetManagerDecoder;  // storage for parameter sets 
+UInt  TDecTop::m_prevPOC = MAX_UINT;
+UInt  TDecTop::m_uiPrevLayerId = MAX_UINT;
+Bool  TDecTop::m_bFirstSliceInSequence = true;
+#endif
+
 //! \ingroup TLibDecoder
 //! \{
@@ -54,7 +61,24 @@
   m_prevRAPisBLA = false;
   m_pocRandomAccess = MAX_INT;          
+#if !SVC_EXTENSION
   m_prevPOC                = MAX_INT;
+#endif
   m_bFirstSliceInPicture    = true;
+#if !SVC_EXTENSION
   m_bFirstSliceInSequence   = true;
+#endif
+#if SVC_EXTENSION 
+  m_layerId = 0;
+#if AVC_BASE
+  m_pBLReconFile = NULL;
+#endif
+#endif
+#if REF_IDX_FRAMEWORK
+  memset(m_cIlpPic, 0, sizeof(m_cIlpPic));
+#endif
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  m_pBLSyntaxFile = NULL;
+#endif
+
 }
 
@@ -68,5 +92,9 @@
 Void TDecTop::create()
 {
+#if SVC_EXTENSION
+  m_cGopDecoder.create( m_layerId );
+#else
   m_cGopDecoder.create();
+#endif
   m_apcSlicePilot = new TComSlice;
   m_uiSliceIdx = 0;
@@ -81,14 +109,74 @@
   
   m_cSliceDecoder.destroy();
+#if REF_IDX_FRAMEWORK
+  for(Int i=0; i<MAX_NUM_REF; i++)
+  {
+    if(m_cIlpPic[i])
+    {
+      //m_cIlpPic[i]->setPicYuvRec(NULL);
+      m_cIlpPic[i]->destroy();
+      delete m_cIlpPic[i];
+      m_cIlpPic[i] = NULL;
+    }
+  }    
+#endif
 }
 
 Void TDecTop::init()
 {
+#if !SVC_EXTENSION
   // initialize ROM
   initROM();
+#endif
+#if SVC_EXTENSION
+  m_cGopDecoder.init( m_ppcTDecTop, &m_cEntropyDecoder, &m_cSbacDecoder, &m_cBinCABAC, &m_cCavlcDecoder, &m_cSliceDecoder, &m_cLoopFilter, &m_cSAO);
+  m_cSliceDecoder.init( m_ppcTDecTop, &m_cEntropyDecoder, &m_cCuDecoder );
+#else
   m_cGopDecoder.init( &m_cEntropyDecoder, &m_cSbacDecoder, &m_cBinCABAC, &m_cCavlcDecoder, &m_cSliceDecoder, &m_cLoopFilter, &m_cSAO);
   m_cSliceDecoder.init( &m_cEntropyDecoder, &m_cCuDecoder );
+#endif
   m_cEntropyDecoder.init(&m_cPrediction);
 }
+
+#if REF_IDX_FRAMEWORK
+Void TDecTop::xInitILRP(TComSPS *pcSPS)
+{
+  if(m_layerId>0)
+  {
+    if (m_cIlpPic[0] == NULL)
+    {
+      for (Int j=0; j<1/*MAX_NUM_REF*/; j++)
+      {
+        m_cIlpPic[j] = new  TComPic;
+        //m_cIlpPic[j]->createWithOutYuv(m_iSourceWidth, m_iSourceHeight, g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, &m_cSPS, true);
+#if SVC_UPSAMPLING
+        m_cIlpPic[j]->create(pcSPS->getPicWidthInLumaSamples(), pcSPS->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, pcSPS, true);
+#else
+        m_cIlpPic[j]->create(pcSPS->getPicWidthInLumaSamples(), pcSPS->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, true);
+#endif
+#if REF_IDX_ME_AROUND_ZEROMV || REF_IDX_ME_ZEROMV || REF_IDX_MFM
+        m_cIlpPic[j]->setIsILR(true);
+#endif
+        for (Int i=0; i<m_cIlpPic[j]->getPicSym()->getNumberOfCUsInFrame(); i++)
+        {
+          m_cIlpPic[j]->getPicSym()->getCU(i)->initCU(m_cIlpPic[j], i);
+        }
+      }
+    }
+  }
+}
+
+Void TDecTop::setILRPic(TComPic *pcPic)
+{
+  if(m_cIlpPic[0])
+  {
+    //m_cIlpPic[0]->setPicYuvRec(pcPic->getFullPelBaseRec());
+    m_cIlpPic[0]->copyUpsampledPictureYuv(pcPic->getFullPelBaseRec(), m_cIlpPic[0]->getPicYuvRec());
+    m_cIlpPic[0]->getSlice(0)->setPOC(pcPic->getPOC());
+    m_cIlpPic[0]->getPicYuvRec()->setBorderExtension(false);
+    m_cIlpPic[0]->getPicYuvRec()->extendPicBorder();
+  }
+}
+#endif
 
 Void TDecTop::deletePicBuffer ( )
@@ -100,8 +188,18 @@
   {
     TComPic* pcPic = *(iterPic++);
+#if SVC_EXTENSION
+    if( pcPic )
+    {
+      pcPic->destroy();
+
+      delete pcPic;
+      pcPic = NULL;
+    }
+#else
     pcPic->destroy();
     
     delete pcPic;
     pcPic = NULL;
+#endif
   }
   
@@ -110,6 +208,8 @@
   m_cLoopFilter.        destroy();
   
+#if !SVC_EXTENSION
   // destroy ROM
   destroyROM();
+#endif
 }
 
@@ -129,7 +229,25 @@
   {
     rpcPic = new TComPic();
+
+#if SVC_EXTENSION //Temporal solution, should be modified
+    if(m_layerId > 0)
+    {
+      TDecTop *pcTDecTopBase = (TDecTop *)getLayerDec( m_layerId-1 );
+      //TComPic*                      pcPic = *(pcTDecTopBase->getListPic()->begin()); 
+      TComPicYuv* pcPicYuvRecBase = (*(pcTDecTopBase->getListPic()->begin()))->getPicYuvRec(); 
+      if(pcPicYuvRecBase->getWidth() != pcSlice->getSPS()->getPicWidthInLumaSamples() || pcPicYuvRecBase->getHeight() != pcSlice->getSPS()->getPicHeightInLumaSamples() )
+      {
+        rpcPic->setSpatialEnhLayerFlag( true );
+      }
+    }
+#endif
     
+#if SVC_UPSAMPLING
+    rpcPic->create ( pcSlice->getSPS()->getPicWidthInLumaSamples(), pcSlice->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, 
+                     conformanceWindow, defaultDisplayWindow, numReorderPics, pcSlice->getSPS(), true);
+#else
     rpcPic->create ( pcSlice->getSPS()->getPicWidthInLumaSamples(), pcSlice->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, 
                      conformanceWindow, defaultDisplayWindow, numReorderPics, true);
+#endif
     rpcPic->getPicSym()->allocSaoParam(&m_cSAO);
     m_cListPic.pushBack( rpcPic );
@@ -152,5 +270,7 @@
     if ( rpcPic->getSlice( 0 )->isReferenced() == false  && rpcPic->getOutputMark() == false)
     {
+#if !SVC_EXTENSION
       rpcPic->setOutputMark(false);
+#endif
       rpcPic->setReconMark( false );
       rpcPic->getPicYuvRec()->setBorderExtension( false );
@@ -168,6 +288,13 @@
   }
   rpcPic->destroy();
+
+#if SVC_UPSAMPLING
+  rpcPic->create ( pcSlice->getSPS()->getPicWidthInLumaSamples(), pcSlice->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth,
+                   conformanceWindow, defaultDisplayWindow, numReorderPics, pcSlice->getSPS(), true);
+
+#else
   rpcPic->create ( pcSlice->getSPS()->getPicWidthInLumaSamples(), pcSlice->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth,
                    conformanceWindow, defaultDisplayWindow, numReorderPics, true);
+#endif
   rpcPic->getPicSym()->allocSaoParam(&m_cSAO);
 }
@@ -187,4 +314,7 @@
   m_cGopDecoder.filterPicture(pcPic);
 
+#if SYNTAX_OUTPUT
+  pcPic->wrireBLSyntax( getBLSyntaxFile(), SYNTAX_BYTES );
+#endif
   TComSlice::sortPicList( m_cListPic ); // sorting for application output
   poc                 = pcPic->getSlice(m_uiSliceIdx-1)->getPOC();
@@ -202,10 +332,18 @@
   cFillSlice.setSPS( m_parameterSetManagerDecoder.getFirstSPS() );
   cFillSlice.setPPS( m_parameterSetManagerDecoder.getFirstPPS() );
+#if SET_SLICE_LAYER_ID
+  cFillSlice.initSlice( m_parameterSetManagerDecoder.getFirstSPS()->getLayerId() );
+#else
   cFillSlice.initSlice();
+#endif
   TComPic *cFillPic;
   xGetNewPicBuffer(&cFillSlice,cFillPic);
   cFillPic->getSlice(0)->setSPS( m_parameterSetManagerDecoder.getFirstSPS() );
   cFillPic->getSlice(0)->setPPS( m_parameterSetManagerDecoder.getFirstPPS() );
+#if SET_SLICE_LAYER_ID
+  cFillPic->getSlice(0)->initSlice( cFillPic->getLayerId() );
+#else
   cFillPic->getSlice(0)->initSlice();
+#endif
   
   TComList<TComPic*>::iterator iterPic = m_cListPic.begin();
@@ -256,5 +394,9 @@
   assert (sps != 0);
 
+#if SVC_EXTENSION
+  if (false == m_parameterSetManagerDecoder.activatePPS(m_apcSlicePilot->getPPSId(), m_apcSlicePilot->getIdrPicFlag(), m_apcSlicePilot->getLayerId() ))
+#else
   if (false == m_parameterSetManagerDecoder.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->getIdrPicFlag()))
+#endif
   {
     printf ("Parameter set activation failed!");
@@ -283,8 +425,16 @@
 }
 
+#if SVC_EXTENSION
+Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, UInt& curLayerId, Bool& bNewPOC )
+#else
 Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay )
+#endif
 {
   TComPic*&   pcPic         = m_pcPic;
+#if SET_SLICE_LAYER_ID
+  m_apcSlicePilot->initSlice( nalu.m_layerId );
+#else
   m_apcSlicePilot->initSlice();
+#endif
 
   if (m_bFirstSliceInPicture)
@@ -324,4 +474,14 @@
 
   // exit when a new picture is found
+#if SVC_EXTENSION
+  bNewPOC = (m_apcSlicePilot->getPOC()!= m_prevPOC);
+  if (m_apcSlicePilot->isNextSlice() && (bNewPOC || m_layerId!=m_uiPrevLayerId) && !m_bFirstSliceInSequence )
+  {
+    m_prevPOC = m_apcSlicePilot->getPOC();
+    curLayerId = m_uiPrevLayerId; 
+    m_uiPrevLayerId = m_layerId;
+    return true;
+  }
+#else
   if (m_apcSlicePilot->isNextSlice() && m_apcSlicePilot->getPOC()!=m_prevPOC && !m_bFirstSliceInSequence)
   {
@@ -333,4 +493,5 @@
     m_prevPOC = m_apcSlicePilot->getPOC();
   }
+#endif
   // actual decoding starts here
   xActivateParameterSets();
@@ -339,4 +500,8 @@
   {
     m_prevPOC = m_apcSlicePilot->getPOC();
+#if SVC_EXTENSION
+    curLayerId = m_layerId;
+    m_uiPrevLayerId = m_layerId;
+#endif
   }
   m_bFirstSliceInSequence = false;
@@ -349,4 +514,54 @@
   if (m_bFirstSliceInPicture)
   {
+#if AVC_BASE
+  if( m_layerId == 1 )
+  {
+    TComPic* pBLPic = (*m_ppcTDecTop[0]->getListPic()->begin());
+    fstream* pFile  = m_ppcTDecTop[0]->getBLReconFile();
+    UInt uiWidth    = pBLPic->getPicYuvRec()->getWidth() - pBLPic->getPicYuvRec()->getPicCropLeftOffset() - pBLPic->getPicYuvRec()->getPicCropRightOffset();;
+    UInt uiHeight   = pBLPic->getPicYuvRec()->getHeight() - pBLPic->getPicYuvRec()->getPicCropTopOffset() - pBLPic->getPicYuvRec()->getPicCropBottomOffset();
+        
+    if( pFile->good() )
+    {
+      UInt64 uiPos = (UInt64) m_apcSlicePilot->getPOC() * uiWidth * uiHeight * 3 / 2;
+
+      pFile->seekg((UInt)uiPos, ios::beg );
+
+      Pel* pPel = pBLPic->getPicYuvRec()->getLumaAddr();
+      UInt uiStride = pBLPic->getPicYuvRec()->getStride();
+      for( Int i = 0; i < uiHeight; i++ )
+      {
+        for( Int j = 0; j < uiWidth; j++ )
+        {
+          pPel[j] = pFile->get();
+        }
+        pPel += uiStride;
+      }
+
+      pPel = pBLPic->getPicYuvRec()->getCbAddr();
+      uiStride = pBLPic->getPicYuvRec()->getCStride();
+      for( Int i = 0; i < uiHeight/2; i++ )
+      {
+        for( Int j = 0; j < uiWidth/2; j++ )
+        {
+          pPel[j] = pFile->get();
+        }
+        pPel += uiStride;
+      }
+
+      pPel = pBLPic->getPicYuvRec()->getCrAddr();
+      uiStride = pBLPic->getPicYuvRec()->getCStride();
+      for( Int i = 0; i < uiHeight/2; i++ )
+      {
+        for( Int j = 0; j < uiWidth/2; j++ )
+        {
+          pPel[j] = pFile->get();
+        }
+        pPel += uiStride;
+      }
+    }
+  }
+#endif
+
     // Buffer initialize for prediction.
     m_cPrediction.initTempBuff();
@@ -361,5 +576,9 @@
     // Recursive structure
     m_cCuDecoder.create ( g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight );
+#if SVC_EXTENSION
+    m_cCuDecoder.init   ( m_ppcTDecTop,&m_cEntropyDecoder, &m_cTrQuant, &m_cPrediction, curLayerId );
+#else
     m_cCuDecoder.init   ( &m_cEntropyDecoder, &m_cTrQuant, &m_cPrediction );
+#endif
     m_cTrQuant.init     ( g_uiMaxCUWidth, g_uiMaxCUHeight, m_apcSlicePilot->getSPS()->getMaxTrSize());
 
@@ -483,9 +702,72 @@
   pcPic->setTLayer(nalu.m_temporalId);
 
+#if SVC_EXTENSION
+  pcPic->setLayerId(nalu.m_layerId);
+  pcSlice->setLayerId(nalu.m_layerId);
+#endif
+
   if (bNextSlice)
   {
     pcSlice->checkCRA(pcSlice->getRPS(), m_pocCRA, m_prevRAPisBLA );
+#if !REF_IDX_FRAMEWORK || AVC_SYNTAX
     // Set reference list
     pcSlice->setRefPicList( m_cListPic );
+#endif
+
+#if SVC_EXTENSION   
+    if(m_layerId > 0)
+    {
+#if AVC_BASE
+      pcSlice->setBaseColPic ( *m_ppcTDecTop[0]->getListPic()->begin() );
+#if AVC_SYNTAX
+      TComPic* pBLPic = pcSlice->getBaseColPic();
+      if( pcSlice->getPOC() == 0 )
+      {
+        // initialize partition order.
+        UInt* piTmp = &g_auiZscanToRaster[0];
+        initZscanToRaster( pBLPic->getPicSym()->getMaxDepth() + 1, 1, 0, piTmp );
+        initRasterToZscan( pBLPic->getPicSym()->getMaxCUWidth(), pBLPic->getPicSym()->getMaxCUHeight(), pBLPic->getPicSym()->getMaxDepth() + 1 );
+      }      
+      pBLPic->getSlice( 0 )->initBaseLayerRPL( pcSlice );
+      pBLPic->readBLSyntax( m_ppcTDecTop[0]->getBLSyntaxFile(), SYNTAX_BYTES );
+#endif
+
+#else
+      TDecTop *pcTDecTop = (TDecTop *)getLayerDec( m_layerId-1 );
+      TComList<TComPic*> *cListPic = pcTDecTop->getListPic();
+      pcSlice->setBaseColPic ( *cListPic, m_layerId );
+#endif
+#if SVC_UPSAMPLING
+      if ( pcPic->isSpatialEnhLayer())
+      {    
+        m_cPrediction.upsampleBasePic( pcPic->getFullPelBaseRec(), pcSlice->getBaseColPic()->getPicYuvRec(), pcPic->getPicYuvRec() );
+      }
+      else
+      {
+        pcPic->setFullPelBaseRec( pcSlice->getBaseColPic()->getPicYuvRec() );
+      }
+      pcSlice->setFullPelBaseRec ( pcPic->getFullPelBaseRec() );
+#endif
+    }
+#endif 
+
+#if REF_IDX_FRAMEWORK
+#if !AVC_SYNTAX
+    // Set reference list
+    pcSlice->setRefPicList( m_cListPic );
+#endif
+    if(m_layerId > 0)
+    {
+      setILRPic(pcPic);
+#if REF_IDX_MFM
+      pcSlice->setRefPOCListILP(m_ppcTDecTop[m_layerId]->m_cIlpPic, pcSlice->getBaseColPic());
+#endif
+
+      pcSlice->addRefPicList ( m_cIlpPic, 
+                               1, 
+                               ((pcSlice->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA) && 
+                                (pcSlice->getNalUnitType() <= NAL_UNIT_CODED_SLICE_CRA)) ? 0: -1);
+    }
+#endif
 
     // For generalized B
@@ -590,6 +872,19 @@
 {
   TComSPS* sps = new TComSPS();
+#if SVC_EXTENSION
+  sps->setLayerId(m_layerId);
+#endif
   m_cEntropyDecoder.decodeSPS( sps );
   m_parameterSetManagerDecoder.storePrefetchedSPS(sps);
+#if REF_IDX_MFM
+  m_pcSPS = sps;
+  setMFMEnabledFlag(sps->getMFMEnabledFlag());
+#endif
+#if REF_IDX_FRAMEWORK
+  if(m_numLayer>0)
+  {
+    xInitILRP(sps);
+  }
+#endif
 }
 
@@ -637,5 +932,9 @@
 }
 
+#if SVC_EXTENSION
+Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, UInt& curLayerId, Bool& bNewPOC)
+#else
 Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay)
+#endif
 {
   // Initialize entropy decoder
@@ -651,4 +950,22 @@
     case NAL_UNIT_SPS:
       xDecodeSPS();
+#if AVC_BASE
+      {
+        TComPic* pBLPic = (*m_ppcTDecTop[0]->getListPic()->begin());
+        if( nalu.m_layerId == 1 && pBLPic->getPicYuvRec() == NULL )
+        {
+#if SVC_UPSAMPLING
+#if AVC_SYNTAX
+          TComSPS* sps = new TComSPS();
+          pBLPic->create( m_ppcTDecTop[0]->getBLWidth(), m_ppcTDecTop[0]->getBLHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, sps, true);
+#else
+          pBLPic->create( m_ppcTDecTop[0]->getBLWidth(), m_ppcTDecTop[0]->getBLHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, NULL, true);
+#endif
+#else
+          pBLPic->create( m_ppcTDecTop[0]->getBLWidth(), m_ppcTDecTop[0]->getBLHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, true);
+#endif
+        }
+      }
+#endif
       return false;
 
@@ -678,5 +995,9 @@
     case NAL_UNIT_CODED_SLICE_RASL_N:
     case NAL_UNIT_CODED_SLICE_TFD:
+#if SVC_EXTENSION
+      return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay, curLayerId, bNewPOC);
+#else
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay);
+#endif
       break;
     default:
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecTop.h	(revision 54)
@@ -72,5 +72,15 @@
 
   TComList<TComPic*>      m_cListPic;         //  Dynamic buffer
+#if SVC_EXTENSION
+  static ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
+#else
   ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
+#endif
+
+#if REF_IDX_MFM
+  TComSPS*               m_pcSPS;
+  Bool                   m_bMFMEnabledFlag;
+#endif
+
   TComSlice*              m_apcSlicePilot;
   
@@ -95,7 +105,31 @@
   TComPic*                m_pcPic;
   UInt                    m_uiSliceIdx;
+#if !SVC_EXTENSION
   Int                     m_prevPOC;
+#endif
   Bool                    m_bFirstSliceInPicture;
+#if !SVC_EXTENSION
   Bool                    m_bFirstSliceInSequence;
+#endif
+
+#if SVC_EXTENSION
+  static UInt             m_prevPOC;        // POC of the previous slice
+  static UInt             m_uiPrevLayerId;  // LayerId of the previous slice
+  static Bool             m_bFirstSliceInSequence;
+  UInt                    m_layerId;      
+  UInt                    m_numLayer;
+  TDecTop**               m_ppcTDecTop;
+#if AVC_BASE
+  fstream*                m_pBLReconFile;
+  Int                     m_iBLSourceWidth;
+  Int                     m_iBLSourceHeight;
+#endif
+#endif 
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  fstream*               m_pBLSyntaxFile;
+#endif
+#if REF_IDX_FRAMEWORK
+  TComPic*                m_cIlpPic[MAX_NUM_REF];                    ///<  Inter layer Prediction picture =  upsampled picture 
+#endif
 
 public:
@@ -109,9 +143,43 @@
 
   Void  init();
+#if SVC_EXTENSION
+  Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, UInt& curLayerId, Bool& bNewPOC);
+#else
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay);
+#endif
   
   Void  deletePicBuffer();
 
   Void executeLoopFilters(Int& poc, TComList<TComPic*>*& rpcListPic);
+
+#if SVC_EXTENSION
+  UInt      getLayerId            () { return m_layerId;              }
+  Void      setLayerId            (UInt layer) { m_layerId = layer; }
+  UInt      getNumLayer           () { return m_numLayer;             }
+  Void      setNumLayer           (UInt uiNum)   { m_numLayer = uiNum;  }
+  TComList<TComPic*>*      getListPic() { return &m_cListPic; }
+  Void                setLayerDec(TDecTop **p)    { m_ppcTDecTop = p; }
+  TDecTop*            getLayerDec(UInt layer)   { return m_ppcTDecTop[layer]; }
+#if AVC_BASE
+  Void      setBLReconFile( fstream* pFile ) { m_pBLReconFile = pFile; }
+  fstream*  getBLReconFile() { return m_pBLReconFile; }
+  Void      setBLsize( Int iWidth, Int iHeight ) { m_iBLSourceWidth = iWidth; m_iBLSourceHeight = iHeight; }
+  Int       getBLWidth() { return  m_iBLSourceWidth; }
+  Int       getBLHeight() { return  m_iBLSourceHeight; }
+#endif
+#endif
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  Void      setBLSyntaxFile( fstream* pFile ) { m_pBLSyntaxFile = pFile; }
+  fstream* getBLSyntaxFile() { return m_pBLSyntaxFile; }
+#endif
+#if REF_IDX_FRAMEWORK
+  Void      xInitILRP(TComSPS *pcSPS);
+  Void      setILRPic(TComPic *pcPic);
+#endif
+#if REF_IDX_MFM
+  TComSPS*  getSPS()                       {return m_pcSPS;}
+  Void      setMFMEnabledFlag(Bool flag)   {m_bMFMEnabledFlag = flag;}
+  Bool      getMFMEnabledFlag()            {return m_bMFMEnabledFlag;}
+#endif
 
 protected:
@@ -120,5 +188,9 @@
 
   Void      xActivateParameterSets();
+#if SVC_EXTENSION
+  Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, UInt& curLayerId, Bool& bNewPOC);
+#else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay);
+#endif
   Void      xDecodeVPS();
   Void      xDecodeSPS();
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.cpp	(revision 54)
@@ -53,5 +53,9 @@
   bsNALUHeader.write(0,1);                    // forbidden_zero_bit
   bsNALUHeader.write(nalu.m_nalUnitType, 6);  // nal_unit_type
+#if SVC_EXTENSION
+  bsNALUHeader.write(nalu.m_layerId, 6); // reserved_one_5bits
+#else
   bsNALUHeader.write(nalu.m_reservedZero6Bits, 6);                   // nuh_reserved_zero_6bits
+#endif
   bsNALUHeader.write(nalu.m_temporalId+1, 3); // nuh_temporal_id_plus1
 
@@ -145,4 +149,7 @@
   naluDest.m_temporalId  = naluSrc.m_temporalId;
   naluDest.m_Bitstream   = naluSrc.m_Bitstream;
+#if SVC_EXTENSION
+  naluDest.m_layerId   = naluSrc.m_layerId;
+#endif
 }
 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/NALwrite.h	(revision 54)
@@ -57,6 +57,13 @@
     NalUnitType nalUnitType,
     UInt temporalID = 0,
+#if SVC_EXTENSION
+    UInt     layerId = 0,
+#endif
     UInt reserved_zero_6bits = 0)
+#if SVC_EXTENSION
+  : NALUnit(nalUnitType, temporalID, layerId, reserved_zero_6bits)
+#else
   : NALUnit(nalUnitType, temporalID, reserved_zero_6bits)
+#endif
   , m_Bitstream()
   {}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.cpp	(revision 54)
@@ -45,8 +45,15 @@
 //////////////////////////////////////////////////////////////////////
 
+#if SVC_EXTENSION
+TEncAnalyze             m_gcAnalyzeAll [MAX_LAYERS];
+TEncAnalyze             m_gcAnalyzeI [MAX_LAYERS];
+TEncAnalyze             m_gcAnalyzeP [MAX_LAYERS];
+TEncAnalyze             m_gcAnalyzeB [MAX_LAYERS];
+#else
 TEncAnalyze             m_gcAnalyzeAll;
 TEncAnalyze             m_gcAnalyzeI;
 TEncAnalyze             m_gcAnalyzeP;
 TEncAnalyze             m_gcAnalyzeB;
+#endif
 
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncAnalyze.h	(revision 54)
@@ -88,4 +88,19 @@
   Void    setFrmRate  (Double dFrameRate) { m_dFrmRate = dFrameRate; } //--CFG_KDY
   Void    clear() { m_dPSNRSumY = m_dPSNRSumU = m_dPSNRSumV = m_dAddBits = m_uiNumPic = 0;  }
+#if SVC_EXTENSION
+  Void    printOut ( Char cDelim, UInt layer )
+  {
+    Double dFps     =   m_dFrmRate; //--CFG_KDY
+    Double dScale   = dFps / 1000 / (Double)m_uiNumPic;
+    
+    printf( "    L%d\t %8d    %c"          "%12.4lf  "    "%8.4lf  "   "%8.4lf  "    "%8.4lf\n",
+           layer,
+           getNumPic(), cDelim,
+           getBits() * dScale,
+           getPsnrY() / (Double)getNumPic(),
+           getPsnrU() / (Double)getNumPic(),
+           getPsnrV() / (Double)getNumPic() );
+  }
+#else
   Void    printOut ( Char cDelim )
   {
@@ -102,4 +117,5 @@
            getPsnrV() / (Double)getNumPic() );
   }
+#endif
   
   Void    printSummaryOut ()
@@ -150,8 +166,15 @@
 };
 
+#if SVC_EXTENSION
+extern TEncAnalyze             m_gcAnalyzeAll [MAX_LAYERS];
+extern TEncAnalyze             m_gcAnalyzeI [MAX_LAYERS];
+extern TEncAnalyze             m_gcAnalyzeP [MAX_LAYERS];
+extern TEncAnalyze             m_gcAnalyzeB [MAX_LAYERS];
+#else
 extern TEncAnalyze             m_gcAnalyzeAll;
 extern TEncAnalyze             m_gcAnalyzeI;
 extern TEncAnalyze             m_gcAnalyzeP;
 extern TEncAnalyze             m_gcAnalyzeB;
+#endif
 
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 54)
@@ -545,5 +545,11 @@
   }
   WRITE_FLAG( pcSPS->getTMVPFlagsPresent()  ? 1 : 0,           "sps_temporal_mvp_enable_flag" );
-
+#if REF_IDX_MFM
+  if( pcSPS->getLayerId() > 0 )
+  {
+    assert(pcSPS->getMFMEnabledFlag());
+    WRITE_FLAG( pcSPS->getMFMEnabledFlag() ? 1 : 0,          "sps_enh_mfm_enable_flag" );
+  }
+#endif
   WRITE_FLAG( pcSPS->getUseStrongIntraSmoothing(),             "sps_strong_intra_smoothing_enable_flag" );
 
@@ -1549,3 +1555,11 @@
   return true;
 }
+
+#if INTRA_BL
+Void TEncCavlc::codeIntraBLFlag( TComDataCU* pcCU, UInt uiAbsPartIdx )
+{
+  assert(0);
+}
+
+#endif
 //! \}
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCavlc.h	(revision 54)
@@ -114,4 +114,7 @@
   Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#if INTRA_BL
+  Void codeIntraBLFlag   ( TComDataCU* pcCU, UInt uiAbsPartIdx );
+#endif
  
   Void codeInterModeFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiEncMode );
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCfg.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibEncoder/TEncCfg.h	(revision 54)
@@ -298,4 +298,11 @@
 
   Bool      m_useStrongIntraSmoothing;                        ///< enable the use of strong intra smoothing (bi_linear interpolation) for 32x32 blocks when reference samples are flat.
+#if SVC_EXTENSION
+  UInt      m_layerId;   
+  UInt      m_numLayer;
+#endif 
+#if REF_IDX_FRAMEWORK
+  Int      m_elRapSliceBEnabled;
+#endif
 
 public:
@@ -692,4 +699,17 @@
   Void setFrameOnlyConstraintFlag(Bool b) { m_frameOnlyConstraintFlag = b; }
 #endif
+
+#if SVC_EXTENSION
+  UInt      getLayerId            () { return m_layerId;              }
+  Void      setLayerId            (UInt layer) { m_layerId = layer; }
+  UInt      getNumLayer           () { return m_numLayer;             }  
+  Void      setNumLayer           (UInt uiNum)   { m_numLayer = uiNum;  }
+  Void      setConformanceMode    (Int mode)     { m_conformanceMode = mode; }
+  Void      setConformanceWindow(Window& conformanceWindow ) { m_conformanceWindow = conformanceWindow; }
+#endif
+#if REF_IDX_FRAMEWORK
+  Void      setElRapSliceTypeB(Int bEnabled) {m_elRapSliceBEnabled = bEnabled;}
+  Int       getElRapSliceTypeB()              {return m_elRapSliceBEnabled;}
+#endif
 };
 
